﻿<%@ Page Language="C#" AutoEventWireup="true" ValidateRequest="false" Theme="adm"
    StylesheetTheme="adm" MasterPageFile="~/adm/sc/admin.master" CodeFile="Process.aspx.cs"
    Inherits="adm_sc_categories_Process" %>

<asp:Content ID="hd" ContentPlaceHolderID="HeadContent" runat="server">
    <title>
        <%= Config.GetUrlCaption() %>
        | Administration | Add or Update Category Information</title>
</asp:Content>
<asp:Content ID="MainContent" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">
    <script type="text/javascript" src="../../../tinymce/tiny_mce.js"></script>
    <script type="text/javascript">
        tinyMCE.init({
            // General options
            // Location of TinyMCE script
            script_url: '../../../tiny_mce_gzip.ashx',
            mode: "textareas",
            theme: "advanced",
            plugins: "table,inlinepopups,preview",
            // Theme options
            theme_advanced_buttons1: "bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,formatselect,|,bullist,|,undo,redo,|,link,unlink,removeformat,code,preview",
            theme_advanced_buttons2: "",
            theme_advanced_buttons3: "",
            theme_advanced_buttons4: "",
            theme_advanced_toolbar_location: "top",
            theme_advanced_toolbar_align: "left",
            theme_advanced_statusbar_location: "bottom",
            theme_advanced_resizing: true,

            // Skin options
            skin: "o2k7",
            skin_variant: "silver"

        });
    </script>
    <script type="text/javascript">
        $(function () {
            $('#<%= txt_term.ClientID %>,#<%=drp_type.ClientID %>,#<%=drp_parent.ClientID %>,#<%=drp_mode.ClientID %>').popover();
            $('#<%= txt_priority.ClientID %>').tooltip();
        }); 
    </script>
    <div class="vkbox">
        <div class="vkbox-header">
            <h3>
                Add or Update Category!</h3>
        </div>
        <div class="vkbox-body">
            <div id="msg" runat="server">
            </div>
            <div class="form-horizontal">
                <fieldset>
                    <div class="control-group" id="photoview" runat="server">
                        <asp:Image ID="img" runat="server" />
                    </div>
                    <div class="control-group">
                        <label class="control-label" for="<%= txt_categoryname.ClientID %>">
                            Category Name:</label>
                        <div class="controls">
                            <asp:TextBox ID="txt_categoryname" MaxLength="100" Width="300" runat="server"></asp:TextBox>
                            &nbsp;<asp:RequiredFieldValidator ID="RequiredFieldValidator4" runat="server" ControlToValidate="txt_categoryname"
                                Display="Dynamic" ErrorMessage="Category Name is required." ToolTip="Category Name is required."
                                ValidationGroup="val_valgroup">
                            </asp:RequiredFieldValidator>
                        </div>
                    </div>
                    <div class="control-group">
                        <label class="control-label" for="<%= txt_term.ClientID %>">
                            Term:</label>
                        <div class="controls">
                            <asp:TextBox ID="txt_term" title="Enter Term" data-content="Term can be used to generate proper category urls by removing special characters e.g You can use term 'tech' for category 'Science &amp; Technology'" MaxLength="50" Width="200" runat="server"></asp:TextBox>
                        </div>
                    </div>
                    <div class="control-group">
                        <label class="control-label" for="<%= drp_type.ClientID %>">
                            Category Type:</label>
                        <div class="controls">
                            <asp:DropDownList ID="drp_type" title="Category Type" data-content="It represent in which section the following category to be listed." SkinID="search_dropdown" OnSelectedIndexChanged="drp_type_SelectedIndexChanged"
                                AutoPostBack="true" runat="server">
                                <asp:ListItem Text="General" Value="3"></asp:ListItem>
                                <asp:ListItem Text="Videos" Value="0" Selected="True"></asp:ListItem>
                                <asp:ListItem Text="Channels" Value="2"></asp:ListItem>
                                <asp:ListItem Text="Abuse Types" Value="4"></asp:ListItem>
                               
                            </asp:DropDownList>
                        </div>
                    </div>
                    <div class="control-group">
                        <label class="control-label" for="<%= drp_parent.ClientID %>">
                            Parent Category:</label>
                        <div class="controls">
                            <asp:DropDownList ID="drp_parent" title="Choose Parent Category" data-content="If you want to put current category as child category within another category, choose parent category from here." SkinID="search_dropdown" AppendDataBoundItems="true"
                                runat="server">
                            </asp:DropDownList>
                        </div>
                    </div>
                    <div class="control-group">
                        <label class="control-label" for="<%= txt_priority.ClientID %>">
                            Priority:</label>
                        <div class="controls">
                            <asp:TextBox ID="txt_priority" title="Prioritize category in listing" MaxLength="4" runat="server"></asp:TextBox>
                            &nbsp;<asp:RequiredFieldValidator ID="req_priority" runat="server" ControlToValidate="txt_priority"
                                Display="Dynamic" ErrorMessage="Priority is required." ToolTip="Priority is required."
                                ValidationGroup="val_valgroup">
                            </asp:RequiredFieldValidator>
                        </div>
                    </div>
                    <div class="control-group">
                        <label class="control-label" for="<%= txt_priority.ClientID %>">
                            Choose Photo (optional):</label>
                        <div class="controls">
                            <asp:FileUpload ID="ph" runat="server" />
                        </div>
                    </div>
                    <div class="control-group">
                        <label class="control-label" for="<%= txt_content.ClientID %>">
                            Description (optional):</label>
                        <div class="controls">
                            <textarea id="txt_content" runat="server" rows="5" style="width: 100%"></textarea>
                        </div>
                    </div>
                    <div class="control-group">
                        <label class="control-label" for="<%= drp_status.ClientID %>">
                            Select Status:</label>
                        <div class="controls">
                            <asp:DropDownList ID="drp_status" SkinID="search_dropdown" Width="200" runat="server">
                                <asp:ListItem Text="Public" Value="0" Selected="True"></asp:ListItem>
                                <asp:ListItem Text="Private" Value="1"></asp:ListItem>
                            </asp:DropDownList>
                        </div>
                    </div>
                    <div class="control-group">
                        <label class="control-label" for="<%= drp_mode.ClientID %>">
                            Mode:</label>
                        <div class="controls">
                            <asp:DropDownList ID="drp_mode" title="Choose Mode" data-content="Group categories in specific sections, e.g in case of cars, you can group categories under, auto shows, brands, region, Tunners, vehicle types, vechicle styles<br />Normal mode is used by default, just add other modes according to your needs manually." SkinID="search_dropdown" Width="200" runat="server">
                                <asp:ListItem Text="Normal" Value="0" Selected="True"></asp:ListItem>
                            </asp:DropDownList>
                            <asp:Label ID="lbl_filename" Visible="false" runat="server"></asp:Label>
                        </div>
                    </div>
                </fieldset>
            </div>
        </div>
        <div class="vkbox-footer">
            <asp:Button ID="btn_add" SkinID="large" ValidationGroup="val_valgroup" runat="server"
                Text="Submit" OnClick="btn_add_Click" />
        </div>
    </div>
</asp:Content>
