﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text;

public partial class categories_Default : System.Web.UI.Page
{
    protected string NavigationClass = "";
    protected string BodyClass = "";
    protected string BodyRight = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        set_bread_links();

        if (Config.isVideos())
        {

            if (vd_sm1 != null)
            {
                // featured videos
                vd_sm1.HeadingTitle = "Recent Videos";
                vd_sm1.NoRecordFoundText = "No featured videos found!";
                vd_sm1.See_All_Url_Tooltip = "Browse all featured videos";
                vd_sm1.EnableNavigation = false;
                vd_sm1.EnableAnimation = false; // disable slide animation
                vd_sm1.EnableDateFilterNavigation = false;
                vd_sm1.TotalColumns = 2; // total number of videos to display
                vd_sm1.Records = 4;
                vd_sm1.Order = "v.date_added desc,v.liked desc, v.views desc";
                vd_sm1.isCache = true; // cache records for specified time interval

                vd_sm1.ShowDate = false;
                vd_sm1.ShowTitle = false;
                vd_sm1.ShowUser = false;

            }
        }
        else
        {
            vd.Visible = false;
        }


        // set meta information
        HtmlHead head = (HtmlHead)Page.Header;
        string meta_title = "ASP.NET Youtube Clone - Video Categories";
        string meta_description = "ASP.NET Youtube Clone - Browse your favorite videos through list of categories";
        MetaTagsBLL.META_StaticPage(this.Page, head, meta_title, meta_description, UrlConfig.Return_Website_Logo_Url(), Config.GetUrl("categories/"));
    }

   
    private void set_bread_links()
    {
        string _rooturl = Config.GetUrl();
        StringBuilder str = new StringBuilder();
        str.Append("<li><a href=\"" + _rooturl + "\">" + Resources.vsk.home + "</a><span class=\"divider\">/</span> </li>\n");
        str.Append("<li><a href=\"" + _rooturl + "videos/\">Videos</a><span class=\"divider\">/</span> </li>\n");
        str.Append("<li class=\"active\">Category List</li>\n");
        bread.InnerHtml = str.ToString();
    }
}