﻿<%@ WebHandler Language="C#" Class="tags" %>

using System;
using System.Web;
using System.Text;
using System.Collections.Generic;

public class tags : IHttpHandler {

    string URL = "";
    // Ajax version of ph_sm.ascx
    string handler_path = Config.GetUrl("handlers/nav/tags.ashx");
    public string CssClass = ""; // Provide link css class
    public string ListingCssClass = "flow_lst"; // "flow_lst" // ver_lst
    public int TotalPages = 1;
    public string Term = ""; // filter tags based on selected category.
    public bool isHeading = true; // Enable / Disable Heading
    public string HeadingTitle = "";
    public bool MultiColumn = false;
    public int TotalColumns = 2; // Display records in n level of columns
    public int Type = 0; // 0: videos, 1: groups, 2: photos, 3: blogs, 4: audio files, 5: general, 6: galleries, 7: forums, 100: all
    public int Tag_Type = 0; // 0: normal tags, 1: search tags, 2: all tags
    public int Tag_Level = 100; // 0: high, 1: medium, 2: low, 100: all
    public int isEnabled = 1; // 0: disabled, 1: enabled, 2: all
    public int Records = 20;
    public string Order = "tagid desc";
    public bool isAll = false;
    public bool MainProfileTag = false;
    public bool isCache = true;
    // More Link Urls
    public string MoreLinkUrl = "";
    public string MoreLinkText = Resources.vsk.seeall;
    public string LinkToolTip = "";
    public string MoreLinkToolTip = "";
    // Load all tags
    public bool EnablePagination = false; // enable pagination in case of loading all tags.
    public int TotalRecords = 0; // total records available
    public string PageDescription = ""; // set meta page description
    public string NoRecordFoundText = "No Tags Found";
    // pagination url
    public string DefaultUrl = "";
    public string Pagination_Url = "";
    private int PageNumber = 1;
   
    // advance ajax navigation
    public bool EnableNavigation = false; // enable top navigation (recent, viewed, liked, favorited etc)
    public string NavigationCssClass = "nav nav-tabs";
    public string NavigationLinkCssClass = "";
    public string NavigationActiveLinkCssClass = "normal-text reverse";
    public int NavigationActiveTab = 0; // 0: Recent, 1: View, 2: Like, 3: Favorite, 4: Comment
    public bool EnableAnimation = true; // Slide show animation when ajax event is called
    public string[] NavigationLinks = new string[] { Resources.vsk.videos, Resources.vsk.audio, Resources.vsk.photos, Resources.vsk.blogs, Resources.vsk.galleries };
    public string[] NavigationLinkOrderFields = new string[] { "0", "4", "2", "3", "6" };
    public string Container = ""; // core container to load all output
    
    public void ProcessRequest(HttpContext context)
    {
        context.Response.ContentType = "text/plain";

        if (context.Request.Params["term"] != null)
            this.Term = context.Request.Params["term"].ToString();

        if (context.Request.Params["type"] != null)
            this.Type = Convert.ToInt32(context.Request.Params["type"]);

        if (context.Request.Params["tagtype"] != null)
            this.Tag_Type = Convert.ToInt32(context.Request.Params["tagtype"]);

        if (context.Request.Params["taglevel"] != null)
            this.Tag_Level = Convert.ToInt32(context.Request.Params["taglevel"]);

        if (context.Request.Params["multicolumn"] != null)
            this.MultiColumn = Convert.ToBoolean(context.Request.Params["multicolumn"]);

        if (context.Request.Params["epage"] != null)
            this.EnablePagination = Convert.ToBoolean(context.Request.Params["epage"]);

        if (context.Request.Params["isenabled"] != null)
            this.isEnabled = Convert.ToInt32(context.Request.Params["isenabled"]);

        if (context.Request.Params["order"] != null)
            this.Order = context.Request.Params["order"].ToString();

        if (context.Request.Params["records"] != null)
            this.Records = Convert.ToInt32(context.Request.Params["records"]);
      
        if (context.Request.Params["pagenumber"] != null)
            this.PageNumber = Convert.ToInt32(context.Request.Params["pagenumber"]);

        if (context.Request.Params["totalpages"] != null)
            this.TotalPages = Convert.ToInt32(context.Request.Params["totalpages"]);

        if (context.Request.Params["tcolumns"] != null)
            this.TotalColumns = Convert.ToInt32(context.Request.Params["tcolumns"]);

        if (context.Request.Params["sallurl"] != null)
            this.MoreLinkUrl = context.Request.Params["sallurl"].ToString();

        if (context.Request.Params["sallt"] != null)
            this.MoreLinkText = context.Request.Params["sallt"].ToString();

        if (context.Request.Params["salltool"] != null)
            this.MoreLinkToolTip = context.Request.Params["salltool"].ToString();
                   
        if (context.Request.Params["cnt"] != null)
            this.Container = context.Request.Params["cnt"].ToString();
      
        if (context.Request.Params["enablenav"] != null)
            this.EnableNavigation = Convert.ToBoolean(context.Request.Params["enablenav"]);

        if (context.Request.Params["enableanim"] != null)
            this.EnableAnimation = Convert.ToBoolean(context.Request.Params["enableanim"]);

        if (context.Request.Params["tab"] != null)
            this.NavigationActiveTab = Convert.ToInt32(context.Request.Params["tab"]);

        if (context.Request.Params["navcss"] != null)
            this.NavigationCssClass = context.Request.Params["navcss"].ToString();

        if (context.Request.Params["navactivecss"] != null)
            this.NavigationActiveLinkCssClass = context.Request.Params["navactivecss"].ToString();

        if (context.Request.Params["navlinkcss"] != null)
            this.NavigationLinkCssClass = context.Request.Params["navlinkcss"].ToString();

        if (context.Request.Params["url"] != null)
            this.URL = context.Request.Params["url"].ToString();

        
        if (context.Request.Params["iscache"] != null)
            this.isCache = Convert.ToBoolean(context.Request.Params["iscache"]);

      
        if (context.Request.Params["navarr"] != null)
        {
            string navarr = context.Request.Params["navarr"].ToString();
            if (navarr.Contains(","))
                this.NavigationLinks = navarr.Split(char.Parse(","));
            else
                this.NavigationLinks[0] = navarr;
        }

        if (context.Request.Params["navarrorder"] != null)
        {
            string navarr = context.Request.Params["navarrorder"].ToString();
            if (navarr.Contains(","))
                this.NavigationLinkOrderFields = navarr.Split(char.Parse(","));
            else
                this.NavigationLinkOrderFields[0] = navarr;
        }

        if (context.Request.Params["lcss"] != null)
            this.ListingCssClass = context.Request.Params["lcss"].ToString();

        if (context.Request.Params["css"] != null)
            this.CssClass = context.Request.Params["css"].ToString();
      
        context.Response.Write(BindList());
    }

    public bool IsReusable
    {
        get
        {
            return false;
        }
    }


    private string BindList()
    {
        StringBuilder str = new StringBuilder();
        // generate top navigation if enabled
        if (this.EnableNavigation)
        {
            str.Append(Generate_Top_Navigation());
        }

        // gallery / photo have same loading type = 5
        int _type = this.Type;
        if (_type == 6)
            _type = 2;

        List<Tags_Struct> _list = TagsBLL.Cache_FetchRecentTags_V2(this.Term, _type, this.Tag_Type, this.Tag_Level, this.isEnabled, this.Records, this.PageNumber, this.Order,this.isCache);
        if (_list.Count > 0)
        {            
            UGeneral ug = new UGeneral();
            int i = 0;
            str.Append("<div class=\"bx_br_bt item_pad_4\">\n");
            if (this.MultiColumn)
            {
                // Multi Column Display
                int total_column_records = Convert.ToInt32(Math.Floor((double)_list.Count / this.TotalColumns));
                int counter = 0;
                int sectionwidth = 30;
                if (this.TotalColumns == 2)
                    sectionwidth = 49;
                else if (this.TotalColumns == 4)
                    sectionwidth = 24;
                else if (this.TotalColumns == 1)
                    sectionwidth = 100;
                str.Append("<div class=\"" + this.ListingCssClass + "\" style=\"float: left; width:" + sectionwidth + "%;\"><ul>\n");
                for (i = 0; i <= _list.Count - 1; i++)
                {
                    if (this.URL != "")
                        str.Append("<li><a href=\"" + Parse_TAGUrl_URL(this.URL, _list[i].TagName, _list[i].Term) + "\" alt=\"" + _list[i].TagName + " " + this.LinkToolTip + "\">" + _list[i].TagName + "</a></li>\n");
                    else
                        str.Append("<li>" + ug.Generate_Tag_Item(_list[i].TagName, _list[i].Records, this.Type, this.CssClass, this.MainProfileTag) + " </li>");
                    counter++;
                    if (counter >= total_column_records)
                    {
                        str.Append("</ul></div>\n");
                        str.Append("<div class=\"" + this.ListingCssClass + "\" style=\"float: left; width: " + sectionwidth + "%;\"><ul>\n");
                        counter = 0;
                    }

                }
                str.Append("</ul></div>\n");
            }
            else
            {
                // flow layout
                str.Append("<div class=\"" + this.ListingCssClass + "\"><ul>\n");
                for (i = 0; i <= _list.Count - 1; i++)
                {
                    if (this.URL != "")
                        str.Append("<li><a href=\"" + Parse_TAGUrl_URL(this.URL, _list[i].TagName, _list[i].Term) + "\" alt=\"" + _list[i].TagName + " " + this.LinkToolTip + "\">" + _list[i].TagName + "</a></li>\n");
                    else
                        str.Append("<li>" + ug.Generate_Tag_Item(_list[i].TagName, _list[i].Records, this.Type, this.CssClass, this.MainProfileTag) + " </li>");
                }
                str.Append("</ul></div>\n");
            }
            str.Append("<div class=\"clear\"></div>\n");
            str.Append("</div>\n");
            if (!this.isAll && this.MoreLinkUrl != "" && !this.EnablePagination)
            {
                // generate more link
                str.Append("<div class=\"item_pad_4_r\"><a href=\"" + Config.GetUrl(this.MoreLinkUrl) + "\" class=\"" + this.CssClass + "\" title=\"" + this.MoreLinkToolTip + "\">" + this.MoreLinkText + "</a></div>");
            }

        }
        else
        {
            str.Append("<div class=\"bx_msg\">");
            str.Append("<h4>" + this.NoRecordFoundText + "</h4>");
            str.Append("</div>");
        }
        return str.ToString();
    }
    
    private string Generate_Top_Navigation()
    {
        StringBuilder str = new StringBuilder();
        string nav_param = "term=" + this.Term + "&tagtype=" + this.Tag_Type + "&taglevel=" + this.Tag_Level + "&multicolumn=" + this.MultiColumn + "&epage=" + this.EnablePagination + "&isenabled=" + this.isEnabled + "&records=" + this.Records + "&pagenumber=1&totalpages=1&sallurl=" + this.MoreLinkUrl + "&sallt=" + this.MoreLinkText + "&salltool=" + this.MoreLinkToolTip + "&tcolumns=" + this.TotalColumns + "&cnt=" + this.Container + "&&enablenav=" + this.EnableNavigation + "&navcss=" + this.NavigationCssClass + "&navactivecss=" + this.NavigationActiveLinkCssClass + "&enableanim=" + this.EnableAnimation + "&navlinkcss=" + this.NavigationLinkCssClass + "&iscache=" + this.isCache + "&lcss=" + this.ListingCssClass + "&css=" + CssClass + "&url=" + this.URL;
        nav_param = nav_param + "" + Generate_Nav_Query();
        string ajax_function_name = "Process_Req_Animate";
        if (!this.EnableAnimation)
            ajax_function_name = "Process_Req";

        if (this.NavigationLinks.Length > 0 && this.NavigationLinkOrderFields.Length > 0)
        {
            string nav_ajax_event = "";
            string nav_active_css = "";
            int i = 0;
            str.Append("<div class=\"nmtabs\">\n");
            string navcss = "";
            if (this.NavigationCssClass != "")
                navcss = " class=\"" + NavigationCssClass + "\"";
            str.Append("<ul" + navcss + ">");
            for (i = 0; i <= this.NavigationLinks.Length - 1; i++)
            {
                nav_ajax_event = ajax_function_name + "('" + handler_path + "','" + nav_param + "&type=" + this.NavigationLinkOrderFields[i].ToString() + "&tab=" + i + "','#" + this.Container + "','POST','');return false;";
                if (this.NavigationActiveTab == i)
                    nav_active_css = " class=\"" + this.NavigationActiveLinkCssClass + "\"";
                else
                    nav_active_css = "";

                string linkcss = "";
                if (this.NavigationLinkCssClass != "")
                    linkcss = " class=\"" + this.NavigationCssClass + "\"";
                str.Append("<li " + nav_active_css + "><a" + linkcss + " href=\"#\" onclick=\"" + nav_ajax_event + "\">" + this.NavigationLinks[i].ToString() + "</a></li>\n");

            }
            str.Append("</ul>");
            str.Append("<div class=\"clear\"></div>\n");
            str.Append("</div>\n");
        }

        return str.ToString();
    }


    // Generate query string for nav linkgs and nav order links array list
    private string Generate_Nav_Query()
    {
        int i = 0;
        StringBuilder nav_links = new StringBuilder();
        StringBuilder nav_order = new StringBuilder();
        for (i = 0; i <= this.NavigationLinks.Length - 1; i++)
        {
            if (i > 0)
            {
                nav_links.Append(",");
                nav_order.Append(",");
            }
            nav_links.Append(this.NavigationLinks[i].ToString());
            nav_order.Append(this.NavigationLinkOrderFields[i].ToString());
        }
        return "&navarr=" + nav_links.ToString() + "&navarrorder=" + nav_order.ToString();
    }
    // replace [CN] with term or categoryname, [CID] with categoryid
    public string Parse_TAGUrl_URL(string input, string categoryname, string term)
    {
        if (term == "")
            term = categoryname;

        return System.Text.RegularExpressions.Regex.Replace(input, @"\[CN\]", UtilityBLL.ReplaceSpaceWithHyphin_v2(term.Trim().ToLower()));
    }
}