﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;
using System.Collections;
using System.Web.Caching;

//***************************************************************
// Core User Control for generating category listings with content previews
//***************************************************************
public partial class modules_cat_lst : System.Web.UI.UserControl
{
    // CSS Properties
    public int BoxTemplate = 0; // Default,
    public string BoxCssClass = ""; // main box css style
    public string HeadingCssClass = ""; // main box heading css style
    public string CategoryLinkCssClass = "big-text bold";
    // New Properties
    public string HeadingTitle = Resources.vsk.categories;
    public int TotalColumns = 2; // show total number of records horizontally
    public int Width = 94;
    public int Height = 60;
    public string Order = "categoryname asc";
    public int Records = 8;
    public bool isAll = true;
    public string See_All_Url = "";
    public string See_All_Text = Resources.vsk.seeall; // "see all";
    public string See_All_Url_Tooltip = "";
    public string NoRecordFoundText = Resources.vsk.categories_video_notfound; //"No videos categories found!";
    public int isAudio = 0;
    public int Mode = 0; // group related categories
    public bool AjaxNav = false; // Show Ajax Navigation to move next, prev records
    public bool MainCategory = false; // single category listings for every type of contents.
    public int MaxAjaxPages = 5; // if 0 then unlimited - allow maximum number of pagination pages ajax pagination crawls
    public bool ShowPreview = true; // Show preview below category link

    public int Type = 0; // 0: videos, 1: photos, 2: galleries, 3: blogs, 4: groups
    public int Gallery_Preview_Type = 0; // 0: photo gallery, 1: video gallery, 2: audio gallery

    public string ContentType = "";
    protected void Page_PreRender(object sender, EventArgs e)
    {
        // prepare box templates
        if (this.BoxCssClass == "")
            PrepareBoxTemplates();

        if (!Page.IsPostBack)
        {
            cmt.InnerHtml = this.HeadingTitle;

            widget.Visible = true;

            // generate output and cache it.
            lst.InnerHtml = BindList();
        }
    }

    private string BindList()
    {
        string contenttype = Resources.vsk.video;// "video";
        
        int categorytype = 0; // video categories
        switch (this.Type)
        {
            case 0:
                if (this.isAudio == 1)
                {
                    categorytype = 7; // audio categories
                    contenttype = Resources.vsk.audio;// "audio";
                }
                else
                {
                    categorytype = 0;
                    contenttype = Resources.vsk.video;// "video";
                }
                break;
            case 1:
                categorytype = 5; // photo categories
                contenttype = Resources.vsk.photo;// "photo";
                break;
            case 2:
                categorytype = 8; // gallery categories
                contenttype = Resources.vsk.photogallery;// "photo gallery";
                break;
            case 3:
                categorytype = 6; // blog categories;
                contenttype = Resources.vsk.blog;// "blog";
                break;
            case 4:
                categorytype = 1; // group categories;
                contenttype = "Groups";
                break;
            case 10:
                categorytype = 11; // qa categories
                contenttype = "Q&amp;A";
                break;
            case 11:
                categorytype = 12; // forum categories
                contenttype = "Forum Topics";
                break;
        }

        string box_width = "100%";
        switch (this.TotalColumns)
        {
            case 2:
                box_width = "48%";
                break;
            case 3:
                box_width = "32%";
                break;
            case 4:
                box_width = "24%";
                break;
            case 5:
                box_width = "19%";
                break;
        }
       

        ArrayList _array = new ArrayList();
        StringBuilder str = new StringBuilder();
        StringBuilder rotator_str = new StringBuilder();
        int ctype = categorytype;
        if (categorytype == 8) // gallery and photo has same categories 
            ctype = 5;
        CategoriesBLL.Process_Category_List_Items_Extended(_array, 0, ctype, this.isAll, this.Records, this.Mode,this.Order,1);
        if (_array.Count > 0)
        {
            int i = 0;
            int count = 0;
            for (i = 0; i <= _array.Count - 1; i++)
            {              
                string category_url = UrlConfig.Prepare_Category_Url(((Category_Struct)_array[i]).ID, ((Category_Struct)_array[i]).Name, "", categorytype, MainCategory);
                str.Append("<div style=\"float:left; width:" + box_width  +";\">");
                str.Append("<div class=\"item_pad_4\">");
                if (this.ContentType != "")
                    contenttype = this.ContentType;
                str.Append("<a href=\"" + category_url + "\" class=\"" + CategoryLinkCssClass + "\" title=\"Browse " + contenttype + " in " + ((Category_Struct)_array[i]).Name + "\">" + ((Category_Struct)_array[i]).Name + "</a>");
                str.Append("</div>");
                if (this.ShowPreview)
                {
                    // Fetch latest record for selected category
                    string _term = ((Category_Struct)_array[i]).Term;
                    if (_term == "")
                        _term = ((Category_Struct)_array[i]).Name;
                    // content preview section
                    switch (this.Type)
                    {
                        case 0:
                            // video or audio
                            str.Append(Generate_Video_Preview(_term, rotator_str, contenttype,category_url));
                            break;
                    }
                }
                    // close content preview section
                    str.Append("</div>");
                    count++;
                    if (count >= this.TotalColumns)
                    {
                        count = 0;
                        str.Append("<div class=\"clear\"></div>");
                    }
                
            }
            str.Append("<div class=\"clear\"></div>"); // clear floating items
            if (this.isAudio == 0 && this.Type==0)
                str.Append("<script type=\"text/javascript\">" + rotator_str.ToString() + "</script>"); // thumb rotator script
            //***********************************
            // show all link section
            //***********************************
            if (!this.isAll && this.See_All_Url != "")
            {
                // display see all link
                if (!this.AjaxNav)
                {
                    // show simple see all
                    str.Append("<div class=\"item_pad_2_r\">");
                    str.Append("<a href=\"" + Config.GetUrl(this.See_All_Url) + "\" title=\"" + this.See_All_Url_Tooltip + "\">" + this.See_All_Text + "</a>");
                    str.Append("</div>");
                }
                else
                {
                    // show advance nav with see all
                    str.Append("<div class=\"item_pad_4 ui-helper-clearfix\">");
                    str.Append("<div style=\"float:left;width:38%;\">\n");
                    str.Append("&nbsp;");
                    str.Append("</div>\n");
                    str.Append("<div style=\"float:left;width:20%; height:30px;\">\n");
                  
                    int total_records_available = CategoriesBLL.Count_CategoriesSummary(ctype, 0, this.Mode);

                    int total_pages = (int)Math.Ceiling((double)total_records_available / this.Records);
                    if (this.MaxAjaxPages > 0 && total_pages > this.MaxAjaxPages)
                        total_pages = this.MaxAjaxPages;
                    if (total_pages > 1)
                    {
                        string handler_path = Config.GetUrl("handlers/nav/cats.ashx");
                        string parameters = "tp=0&mode=" + this.Mode + "&isaudio=" + this.isAudio + "&order=" + Order + "&records=" + this.Records + "&pagenumber=2&totalpages=" + total_pages + "&sallurl=" + this.See_All_Url + "&sallt=" + this.See_All_Text + "&salltool=" + this.See_All_Url_Tooltip + "&tcolumns=" + this.TotalColumns + "&width=" + this.Width + "&height=" + this.Height + "&cnt=" + lst.ClientID + "&mcat=" + this.MainCategory + "&catcss=" + this.CategoryLinkCssClass + "&spreview=" + this.ShowPreview + "&gtp=" + Gallery_Preview_Type;
                        string ajax_event = "Process_Req_Animate('" + handler_path + "','" + parameters + "','#" + lst.ClientID + "','POST','');return false;";
                        str.Append("<a href=\"#\" onclick=\"" + ajax_event + "\" title=\"Browse Next Records\" class=\"btn btn-mini\"><i class=\"icon-arrow-right\"></i></a>");

                    }
                    str.Append("</div>\n");
                    str.Append("<div style=\"float:right;width:38%;\">\n");
                    str.Append("<div class=\"item_pad_4_r\">\n");
                    str.Append("<a href=\"" + this.See_All_Url + "\" title=\"" + this.See_All_Url_Tooltip + "\">" + this.See_All_Text + "</a>");
                    str.Append("</div>\n");
                    str.Append("</div>\n");
                    str.Append("<div class=\"clear\"></div>\n");
                    str.Append("</div>");
                }

            }
            //**********************************
            // close show all link section
            //**********************************
        }
        return str.ToString();
      
    }

    private string Generate_Video_Preview(string term, StringBuilder rotator_str, string contenttype,string categoryurl)
    {
        StringBuilder str = new StringBuilder();
        VideoItem vd = new VideoItem();
        int records = 6;
        if (this.TotalColumns > 1)
        {
            records = 1;
            vd.ShowTitle = true;
            vd.ShowViews = true;
            vd.Width = this.Width;
            vd.Height = this.Height;
        }
        else
        {
            vd.isHoverEffect = true;
            vd.ShowTitle = false;
            vd.ShowViews = false;
            vd.Width = 80;
            vd.Height = 55;
        }
        // query
        Video_Struct query = new Video_Struct();
        query.Term = term;
        query.isFeatured = 2;
        query.Type = this.isAudio;
        query.UserName = "";
        query.Month = 0;
        query.Year = 0;
        query.Filter = 0;
        query.isEnabled = 1;
        query.isReviewed = 1;
        query.isPrivate = 0;
        query.isAdult = 2;
        query.isExternal = 3;
        query.Order = "date_added desc";
        query.PageSize = records;
        query.SearchType = 0;
        query.DateFilter = 0;
        query.isCache = false;
        query.Mode = 0;
        query.GalleryID = 0;
        query.PageNumber = 1;
        VideoBLL vbll = new VideoBLL();
        List<Video_Struct> _list = vbll.Fetch_Videos_Limit(query);
        if (_list.Count > 0)
        {
            if (this.TotalColumns == 1)
                str.Append("<div class=\"bx_br_both\">\n"); // add top and bottom border for listing
            int i = 0;
            for (i = 0; i <= _list.Count - 1; i++)
            {
                // generate thumb rotator script for single video item      
                if (this.isAudio == 0 && _list[0].Embed_Script == "")
                    rotator_str.Append(UGeneral.Generate_Thumb_Rotator_Script(_list[0].ThumbFileName));
                         
                vd.Type = this.isAudio;
                vd.ShowDate = false;
                vd.ShowAuthor = false;
                vd.ShowDescription = false;
                vd.ShowTags = false;
                vd.ShowCategories = false;
                vd.BoxSpace = 10;

                vd.ContentLayout = 0;
                vd.BoxWidth = 95;
                vd.BoldLinkCssClass = "bold";
                // generate list
                str.Append(vd.Process(_list[i]));
            }
            if (_list.Count >= records && this.TotalColumns == 1)
            {
                str.Append("<div style=\"float:left; padding:65px 0px 0px 10px; width:30px;\">\n");
                str.Append("<a href=\"" + categoryurl + "\" title=\"browse more videos in this category\">more..</a>\n");
                str.Append("</div>\n");
            }
            str.Append("<div class=\"clear\"></div>\n");
            if (this.TotalColumns == 1)
                str.Append("</div>\n"); // close border listing
        }
        return str.ToString();
    }
   
   
    private void PrepareBoxTemplates()
    {
        this.BoxCssClass = UGeneral.Return_Box_Css(this.BoxTemplate);
        this.HeadingCssClass = UGeneral.Return_Heading_Css(this.BoxTemplate);
    }
       

}