﻿using System;
using System.Collections.Generic;

using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;
using System.Text;

public partial class video2_modules_vr : System.Web.UI.UserControl
{
    private long _videoid = 0;
    private int _mediatype = 0; // 0: video, 1: audio
    private int _videoresponses = 0;
    private long _response_videoid = 0;
    private int _pagesize = 2;

    public long VideoID
    {
        set { _videoid = value; }
        get { return _videoid; }
    }

    public long Response_VideoID
    {
        set { _response_videoid = value; }
        get { return _response_videoid; }
    }

    public int MediaType
    {
        set { _mediatype = value; }
        get { return _mediatype; }
    }

    public int VideoResponses
    {
        set { _videoresponses = value; }
        get { return _videoresponses; }
    }

    public int PageSize
    {
        set { _pagesize = value; }
        get { return _pagesize; }
    }

    protected void Page_PreRender(object sender, EventArgs e)
    {
        if (this.VideoID == 0)
        {
            vr.Visible = false;
            return;
        }
       
        if (!Page.IsPostBack)
        {
            if (this.VideoResponses <= 0 && this.Response_VideoID==0)
            {
                vr.Visible = false;
                return;
            }

            if (this.VideoResponses > 2)
            {
                seeall.Visible = true;
                seeall.HRef = Config.GetUrl() + "video/responses/" + this.VideoID + ".aspx";
            }
            else
            {
                seeall.Visible = false;
            }
            Load_VideoResponses();
        }
    }

    private void Load_VideoResponses()
    {
        StringBuilder str = new StringBuilder();
        StringBuilder rotator_str = new StringBuilder();
        if (this.Response_VideoID > 0)
        {
            string videoresponse_title = VideoBLL.Get_Field_Value(this.Response_VideoID, "title"); 
            string videoresponse_url =UrlConfig.Prepare_Video_Preview_Url(this.Response_VideoID,videoresponse_title,false);
            
            str.Append("<div class=\"item_pad_4\">");
            str.Append("This video is a response to <a href=\"" + videoresponse_url + "\" title=\"" + videoresponse_title + "\">" + videoresponse_title + "</a>");
            str.Append("</div>");
        }
        if (this.VideoResponses <= 0)
        {
            main.InnerHtml = str.ToString();
            return;
        }
        List<Video_Struct> _list = VideoBLL.Load_VideoResponses(this.VideoID, 1, this.PageSize, this.MediaType);
        if (_list.Count > 0)
        {
            // load comments
            int i = 0;
            str.Append("<div class=\"item_pad_4\">");
            VideoItem video = new VideoItem();
            for (i = 0; i <= _list.Count - 1; i++)
            {
                // generate thumb rotator script for single video item                
                rotator_str.Append(UGeneral.Generate_Thumb_Rotator_Script(_list[i].ThumbFileName));
                video.ShowDate = false;
                video.ShowTitle = true;
                video.ShowAuthor = true;
                video.ShowViews = false;
                video.ShowDownloads = false;
                video.BoxWidth = 100;
                video.Width = 94;
                video.Height = 60;
                video.BoxSpace = 6;
                video.isAdmin = false;
                video.isHoverEffect = false;
                video.TitleLength = 0;
                video.ContentLayout = 0; // 0: contents on bottom, 1: contents on left;
                video.LeftWidth = 45; // % // works with contentlayout=1;
                video.RightWidth = 54; // % // works with contentlayout=1;
                str.Append(video.Process(_list[i]));
                video.BreakLine = false;
            }
            str.Append("</div>");
            str.Append("<div class=\"clear\"></div>"); // clear floating items
            str.Append("<script type=\"text/javascript\">" + rotator_str.ToString() + "</script>"); // thumb rotator script
            main.InnerHtml = str.ToString();
        }
        else
        {
            vr.Visible = false;
        }
    }
}