﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;

public partial class videos_category_MostCommented : System.Web.UI.Page
{
    protected string NavigationClass = "";
    protected string BodyClass = "";
    protected string BodyRight = "";
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            // process website layout
            Process_Layout();

            if (Request.Params["catname"] != null)
            {
                string tagname = UtilityBLL.UppercaseFirst(UtilityBLL.ReplaceHyphinWithSpace(Request.Params["catname"].ToString().Trim()), true);

                lst1.isListStatus = true;
                lst1.isListNav = true;
                lst1.Term = tagname;
                lst1.SearchType = 0;

                lst1.PageTitle = tagname + " - Most Commented Videos"; //Resources.vsk.videos_category_cmt_title.Replace("[term]", tagname);
                lst1.PageDescription = Resources.vsk.videos_category_cmt_desc.Replace("[term]", tagname.ToLower()); 
                lst1.NoRecordFoundText = Resources.vsk.videos_category_notfound.Replace("[term]", tagname); 
                lst1.isFeatured = 2; // load both featured and normal videos
                lst1.isAudio = 0; // load only videos
                lst1.isPrivate = 0; // load only public videos
                lst1.Order = "v.comments desc, v.date_added desc, v.liked desc, v.views desc";
                lst1.isCache = true;
                lst1.PageSize = Site_Settings.Video_Page_Size;

                // pagination urls
                lst1.DefaultUrl = "videos/category/mostcommented/" + Request.Params["catname"].ToString() + ".aspx";
                lst1.Pagination_Url = "videos/category/mostcommented/" + Request.Params["catname"].ToString() + "_[p].aspx";
                // top navigation urls
                lst1.Recent_Url = "videos/category/" + Request.Params["catname"].ToString() + ".aspx";
                lst1.MostViewed_Url = "videos/category/mostviewed/" + Request.Params["catname"].ToString() + ".aspx";
                lst1.MostFavorited_Url = "videos/category/mostfavorited/" + Request.Params["catname"].ToString() + ".aspx";
                lst1.Toprated_Url = "videos/category/toprated/" + Request.Params["catname"].ToString() + ".aspx";
                lst1.MostCommented_Url = "videos/category/mostcommented/" + Request.Params["catname"].ToString() + ".aspx";

                lst1.TabIndex = 4; // Most Commented
               
                set_bread_links(tagname + "(most commented)");
            }
            else
            {
                Response.Redirect(Config.GetUrl("videos/"));
            }
        }
    }

    private void set_bread_links(string title)
    {
        string _rooturl = Config.GetUrl();
        StringBuilder str = new StringBuilder();
        str.Append("<li><a href=\"" + _rooturl + "\">" + Resources.vsk.home + "</a><span class=\"divider\">/</span> </li>\n");
        str.Append("<li><a href=\"" + _rooturl + "videos/\">Videos</a><span class=\"divider\">/</span> </li>\n");
        str.Append("<li><a href=\"" + _rooturl + "videos/categories/\">Categories</a><span class=\"divider\">/</span> </li>\n");
        str.Append("<li class=\"active\">" + title + "</li>\n");
        bread.InnerHtml = str.ToString();
    }

    // Core script to handle website layout
    private void Process_Layout()
    {
        UGeneral ug = new UGeneral();
        int selected_layout_option = Site_Settings.NavigationSection;
        if (selected_layout_option == 2)
        {
            // three column layout
            navigation1.Visible = false; // advance navigation disable
            navigation_sm1.Visible = true; // first column simple navigation
            third_nav1.Visible = true; // third column navigation
        }
        else
        {
            // two column layout
            navigation1.Visible = true;
            navigation_sm1.Visible = false;
            third_nav1.Visible = false;

        }

        NavigationClass = ug.Return_Navigation_Class();
        BodyClass = ug.Return_Body_Class();
        BodyRight = ug.Return_RightNav_Class();

    }
}