﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;

public partial class videos_modules_vd_sm : System.Web.UI.UserControl
{
    // CSS Properties
    public int BoxTemplate = 0; // Default,
    public string BoxCssClass = ""; // main box css style
    public string HeadingCssClass = ""; // main box heading css style
    // New Properties
    public string HeadingTitle = Resources.vsk.recentlyaddedvideos; // "Just Added Videos";
    public string Term = ""; // to load photos based on term
    public int SearchType = 0; // 0: category match, 1: tag cloud match, 2: category or tag match, 3: broad search (category, tag, title, description)
    public int TotalColumns = 4; // show total number of records horizontally
   
    public int isfeatured = 2; // 0: normal, 1: wallpaper, 2: both
    public int isAudio = 0; // 0: video, 1: audio, 2: both
    public int CategoryID = 0; // Backward compatibility with old vsk 5.6
    public int isPrivate = 0; // 0: public, 1: private, 2: unlisted, 3: all
    public int isAdult = 2; //0: non adult, 1: adult, 2: both
    public int isExternal = 3; // 0: website videos, 1: embed videos, 3: both embed and website videos
    public string Order = "date_added desc";
    public bool isCache = false; // cache list of records for specified time interval
    public int Records = 8;
    public string See_All_Url = "";
    public string See_All_Text = Resources.vsk.seeall;
    public string See_All_Url_Tooltip = "";
    public string NoRecordFoundText = "No videos yet uploaded!";
    public long AlbumId = 0; // Filter videos and audio files via AlbumID
    // Author / User Related
    public string UserName = ""; // Load user specific records
    // Action Related
    public int isEnabled = 1; // 1: Only enabled records, 0: Disabled Records, 2: Both enabled and disabled records
    public int isApproved = 1; // 1: Only approved records, 0: Not reviewed records only, 2: Both approved and unapproved records

    // Filter Related
    public int Filter = 0; // (0: All Time, 1: Today Viewed, 2: This Week Viewed, 3: This Month Viewed)
    public int AddedFilter = 0; // 0 All Time, 1: Today Added, 2: This Week Added, 3: This Month Added
    // Archive Related
    public int Month = 0; // month id to filter record based on month
    public int Year = 0; // year to filter records based on year

    public bool EditMode = false; // show edit link if enabled

    public bool AjaxNav = false; // Show Ajax Navigation to move next, prev records
    public int MaxAjaxPages = 5; // if 0 then unlimited - allow maximum number of pagination pages ajax pagination crawls

    public bool EnableNavigation = false; // enable top navigation (recent, viewed, liked, favorited etc)
    public string NavigationCssClass = "nav nav-tabs";
    public string NavigationLinkCssClass = "";
    public string NavigationActiveLinkCssClass = "active";
    public int NavigationActiveTab = 0; // 0: Recent, 1: View, 2: Like, 3: Favorite, 4: Comment
    public bool EnableAnimation = true; // Slide show animation when ajax event is called
 
    // Advance Date Filter Links
    public bool EnableDateFilterNavigation = false; // enable date filter navigation links (Today, This Week, This Month, All Time)
    public string DateFilterNavigationCssClass = "item_pad_4 bx_br_bt hor_lst";
    public string DateFilterLinkCssClass = "";
    public string DateFilterActiveLinkCssClass = "active";
    // Advance Order Links
    public string[] NavigationLinks = new string[] { Resources.vsk.recent, Resources.vsk.viewed, Resources.vsk.favorites, Resources.vsk.liked, Resources.vsk.comments };
    public string[] NavigationLinkOrderFields = new string[] { "v.date_added desc", "v.views desc", "v.favorites", "v.liked desc", "v.comments desc" };
    // Customized Video Item
    public bool ShowDate = true;
    public bool ShowTitle = true;
    public bool ShowUser = true;
    public bool ShowViews = true;
    public bool ShowDownload = false;
    public int Mode = 0;

    // private control user properties
    string handler_path = Config.GetUrl("handlers/nav/media.ashx");
    string parameters = "";
    string ajax_event = "";
    // Version 2.0 Properties
    public int ContentLayout = 0; // 0: content on bottom, 1:content on left side
    public int BoxWidth = 150; // complete width of box
    public int BoxSpace = 15; // space between each item
    public int Width = 130;
    public int Height = 72;
    public int LeftWidth = 45; // % width of left side of box
    public int RightWidth = 54; // % width of right side of box
    public bool isHoverEffect = false; // hover effect on mouse move

    public int TitleLength = 35; // max length of title to show

    public bool isAdmin = false; // show admin mode
    // Advance Options
    public bool LoadFavorites = false;
    public bool LoadLiked = false;
    protected void Page_PreRender(object sender, EventArgs e)
    {
        // Toggle on | off
        if (this.isAudio == 0)
        {
            // video selected
            // check for video feature
            if (!Config.isVideos())
            {
                widget.Visible = false;
                return;
            }
        }
       
        // prepare box templates
        if (this.BoxCssClass == "")
            PrepareBoxTemplates();

        if (!Page.IsPostBack)
        {
            cmt.InnerHtml = this.HeadingTitle;

            widget.Visible = true;
            BindList();
        }
    }
    
    public void BindList()
    {
        StringBuilder str = new StringBuilder();
        StringBuilder rotator_str = new StringBuilder();
        // generate top navigation if enabled
        if (this.EnableNavigation)
        {
            str.Append(Generate_Top_Navigation());
        }
        // generate datefilter navigation
        //if (this.EnableDateFilterNavigation)
        //{
        //    str.Append(Generate_DateFilter_Navigation());
        //}
        // query
        Video_Struct query = new Video_Struct();
        query.Term = this.Term;
        query.isFeatured = this.isfeatured;
        query.Type = this.isAudio;
        query.UserName = this.UserName;
        query.Month = this.Month;
        query.Year = this.Year;
        query.Filter = this.Filter;
        query.isEnabled = this.isEnabled;
        query.isReviewed = this.isApproved;
        query.isPrivate = this.isPrivate;
        query.isAdult = this.isAdult;
        query.isExternal = this.isExternal;
        query.Order = this.Order;
        query.PageSize = this.Records;
        query.SearchType = this.SearchType;
        query.DateFilter = this.AddedFilter;
        query.isCache = this.isCache;
        query.Mode = this.Mode;
        query.GalleryID = this.AlbumId;
        query.PageNumber = 1;
        query.isPublished = 1; // only published videos
        query.LoadFavorites = this.LoadFavorites;
        query.LoadLiked = this.LoadLiked;
        VideoBLL vbll = new VideoBLL();
        List<Video_Struct> _list = vbll.Load_Videos_Limit(query);
        if (_list.Count > 0)
        {            
            int i = 0;
            int counter = 0;
            VideoItem video = new VideoItem();
            str.Append("<div class=\"bx_br_bt item_pad_4\">\n");
          
            for (i = 0; i <= _list.Count - 1; i++)
            {
                counter = counter + 1;
                if (counter >= this.TotalColumns)
                {
                    counter = 0;
                    video.BreakLine = true;
                }
                // generate thumb rotator script for single video item  
                if (this.isAudio == 0 && _list[i].Embed_Script == "") // no video added through embed script
                    rotator_str.Append(UGeneral.Generate_Thumb_Rotator_Script(_list[i].ThumbFileName));
                // single comment item
                video.Type = this.isAudio;
                video.ShowDate = this.ShowDate;
                video.ShowTitle = this.ShowTitle;
                video.ShowAuthor = this.ShowUser;
                video.ShowViews = this.ShowViews;
                video.ShowDownloads = this.ShowDownload;
                video.Width = this.Width;
                video.Height = this.Height;
                video.isAdmin = this.isAdmin;
                video.isHoverEffect = this.isHoverEffect;
                video.BoxSpace = this.BoxSpace;

                video.TitleLength = this.TitleLength;
                // two level video listing
                video.ContentLayout = this.ContentLayout;
                video.BoxWidth = this.BoxWidth;
                video.LeftWidth = this.LeftWidth; // %
                video.RightWidth = this.RightWidth; // %
                //video.DateFormat = 2;
                //video.ShowDescription = true;
                //video.DescriptionLength = 200;
                //video.ShowTags = true;
                //video.ShowCategories = true;
                //video.Showliked = true;
                //video.ShowDisliked = true;
                //video.ShowApproved = true;
                //video.ShowDisabled = true;
                //video.ShowAdult = true;
                //video.ShowComments = true;
                //video.ShowEditLink = true;
                //video.ShowFeatured = true;
                //video.EditLinkUrl = "http://www.abc.com";
                //video.BoxCssClass = "wiget_item bx_br_bt";
                //_list[i].Tags = "sample,apple,banana";
                //video.CategoriesLength = 30;
                //video.CategoryCaption = "Categories: ";
                //_list[i].Categories = "apple,box animation,another, first, fire, hover effect, mystry, biology, shark, fish";
                //_list[i].Description = "this is sample gallery demonstration to view how everything is working";
                //video.ShowDescription = true;
                if (this.isfeatured == 0 && _list[i].isFeatured == 1)
                {
                    video.isAltColor = true;
                    //med.isAltColor = true;
                }
                // generate list
                str.Append(video.Process(_list[i]));
            }
            str.Append("<div class=\"clear\"></div>"); // clear floating items
            if (this.isAudio == 0)
                str.Append("<script type=\"text/javascript\">" + rotator_str.ToString() + "</script>"); // thumb rotator script
            str.Append("</div>\n");

            if (_list.Count >= this.Records && this.See_All_Url != "")
            {
                // display see all link
                if (!this.AjaxNav)
                {
                    // show simple see all
                    str.Append("<div class=\"item_pad_2_r\">");
                    str.Append("<a href=\"" + Config.GetUrl(this.See_All_Url) + "\" title=\"" + this.See_All_Url_Tooltip + "\">" + this.See_All_Text + "</a>");
                    str.Append("</div>");
                }
                else
                {
                    // show advance nav with see all
                    str.Append("<div class=\"item_pad_4 ui-helper-clearfix\">");
                    str.Append("<div style=\"float:left;width:38%;\">\n");
                    str.Append("&nbsp;");
                    str.Append("</div>\n");
                    str.Append("<div style=\"float:left;width:20%; height:30px;\">\n");
                    int total_records_available = vbll.Count_Videos_V4(query);
                    int total_pages = (int)Math.Ceiling((double)total_records_available / this.Records);
                    if (this.MaxAjaxPages > 0 && total_pages > this.MaxAjaxPages)
                        total_pages = this.MaxAjaxPages;
                    if (total_pages > 1)
                    {    
                        // prepare ajax parameters()
                        parameters = "term=" + this.Term + "&catid=" + this.CategoryID + "&isfeatured=" + this.isfeatured + "&isaudio=" + this.isAudio + "&user=" + this.UserName + "&month=" + this.Month + "&year=" + this.Year + "&filter=" + this.Filter + "&isenabled=" + this.isEnabled + "&isapproved=" + this.isApproved + "&isprivate=" + this.isPrivate + "&isadult=" + this.isAdult + "&isexternal=" + this.isExternal + "&order=" + Order + "&records=" + this.Records + "&searchtype=" + SearchType + "&pagenumber=2&totalpages=" + total_pages + "&sallurl=" + this.See_All_Url + "&sallt=" + this.See_All_Text + "&salltool=" + this.See_All_Url_Tooltip + "&tcolumns=" + this.TotalColumns + "&emode=" + this.EditMode + "&width=" + this.Width + "&height=" + this.Height + "&cnt=" + lst.ClientID + "&afilter=" + this.AddedFilter + "&sdate=" + this.ShowDate + "&sviews=" + this.ShowViews + "&stitle=" + this.ShowTitle + "&suser=" + this.ShowUser + "&enablenav=" + this.EnableNavigation + "&navcss=" + this.NavigationCssClass + "&navactivecss=" + this.NavigationActiveLinkCssClass + "&enableanim=" + this.EnableAnimation + "&navlinkcss=" + this.NavigationLinkCssClass + "&edfnav=" + this.EnableDateFilterNavigation + "&dnavcss=" + DateFilterNavigationCssClass + "&dlinkcss=" + DateFilterLinkCssClass + "&dactivecss=" + DateFilterActiveLinkCssClass + "&aid=" + this.AlbumId;
                        parameters = parameters + "" + Generate_Nav_Query();
                        string ajax_function_name = "Process_Req_Animate";
                        if (!this.EnableAnimation)
                            ajax_function_name = "Process_Req";
                        ajax_event = ajax_function_name + "('" + handler_path + "','" + parameters + "','#" + lst.ClientID + "','POST',''); return false;";
                        str.Append("<a href=\"#\" onclick=\"" + ajax_event + "\" title=\"Browse Next Records\" class=\"btn btn-mini\"><i class=\"icon-arrow-right\"></i></a>");
                    }
                    str.Append("</div>\n");
                    str.Append("<div style=\"float:right;width:38%;\">\n");
                    str.Append("<div class=\"item_pad_4_r\">\n");
                    str.Append("<a href=\"" + Config.GetUrl(this.See_All_Url) + "\" title=\"" + this.See_All_Url_Tooltip + "\">" + this.See_All_Text + "</a>");
                    str.Append("</div>\n");
                    str.Append("</div>\n");
                    str.Append("<div class=\"clear\"></div>\n");
                    str.Append("</div>");
                }

            }
        }
        else
        {
            str.Append("<div class=\"bx_msg\">");
            str.Append("<h4>" + this.NoRecordFoundText + "</h4>");
            str.Append("</div>");
        }
        lst.InnerHtml = str.ToString();
    }

    // Generate Top Navigation
    private string Generate_Top_Navigation()
    {
        StringBuilder str = new StringBuilder();
        string nav_param = "term=" + this.Term + "&catid=" + this.CategoryID + "&isfeatured=" + this.isfeatured + "&isaudio=" + this.isAudio + "&user=" + this.UserName + "&month=" + this.Month + "&year=" + this.Year + "&filter=" + this.Filter + "&isenabled=" + this.isEnabled + "&isapproved=" + this.isApproved + "&isprivate=" + this.isPrivate + "&isadult=" + this.isAdult + "&isexternal=" + this.isExternal + "&records=" + this.Records + "&searchtype=" + SearchType + "&pagenumber=1&totalpages=1&sallurl=" + this.See_All_Url + "&sallt=" + this.See_All_Text + "&salltool=" + this.See_All_Url_Tooltip + "&tcolumns=" + this.TotalColumns + "&emode=" + this.EditMode + "&width=" + this.Width + "&height=" + this.Height + "&cnt=" + lst.ClientID + "&sdate=" + this.ShowDate + "&sviews=" + this.ShowViews + "&stitle=" + this.ShowTitle + "&suser=" + this.ShowUser + "&enablenav=" + this.EnableNavigation + "&navcss=" + this.NavigationCssClass + "&navactivecss=" + this.NavigationActiveLinkCssClass + "&enableanim=" + this.EnableAnimation + "&navlinkcss=" + this.NavigationLinkCssClass + "&iscache=" + this.isCache + "&edfnav=" + this.EnableDateFilterNavigation + "&dnavcss=" + DateFilterNavigationCssClass + "&dlinkcss=" + DateFilterLinkCssClass + "&dactivecss=" + DateFilterActiveLinkCssClass + "&aid=" + this.AlbumId;
        nav_param = nav_param + "" + Generate_Nav_Query();
        string ajax_function_name = "Process_Req_Animate";
        if (!this.EnableAnimation)
            ajax_function_name = "Process_Req";

        if (this.NavigationLinks.Length > 0 && this.NavigationLinkOrderFields.Length > 0)
        {
            string nav_ajax_event = "";
            string nav_active_css = "";
            int i = 0;
            str.Append("<div class=\"nmtabs\">\n");
            string navcss = "";
            if (this.NavigationCssClass != "")
                navcss = " class=\"" + NavigationCssClass + "\"";
            str.Append("<ul" + navcss + ">");
            for (i = 0; i <= this.NavigationLinks.Length - 1; i++)
            {
                nav_ajax_event = ajax_function_name + "('" + handler_path + "','" + nav_param + "&order=" + this.NavigationLinkOrderFields[i].ToString() + "&tab=" + i + "&afilter=" + this.AddedFilter + "','#" + lst.ClientID + "','POST',''); return false;";
                if (this.NavigationActiveTab == i)
                    nav_active_css = " class=\"" + this.NavigationActiveLinkCssClass + "\"";
                else
                    nav_active_css = "";

                string linkcss = "";
                if (this.NavigationLinkCssClass != "")
                    linkcss = " class=\"" + this.NavigationCssClass + "\"";
                str.Append("<li " + nav_active_css + "><a" + linkcss + " href=\"#\" onclick=\"" + nav_ajax_event + "\">" + this.NavigationLinks[i].ToString() + "</a></li>\n");
            }
            // Generate Filter -> Today, this Week, this month added
            if (this.EnableDateFilterNavigation)
            {
                str.Append("<li class=\"dropdown\"><a href=\"#\" class=\"dropdown-toggle\" data-toggle=\"dropdown\">Filter <b class=\"caret\"></b></a>\n");
                str.Append("<ul class=\"dropdown-menu\">\n");
                str.Append(Generate_DateFilter());
                str.Append("</ul>\n");
                str.Append("</li>\n");
            }
            str.Append("</ul>");
            str.Append("<div class=\"clear\"></div>\n");
            str.Append("</div>\n");
        }

        return str.ToString();
    }
    // Generate Date Filter Navigation
    private string Generate_DateFilter()
    {
        StringBuilder str = new StringBuilder();
        string nav_param = "term=" + this.Term + "&catid=" + this.CategoryID + "&isfeatured=" + this.isfeatured + "&isaudio=" + this.isAudio + "&user=" + this.UserName + "&month=" + this.Month + "&year=" + this.Year + "&filter=" + this.Filter + "&isenabled=" + this.isEnabled + "&isapproved=" + this.isApproved + "&isprivate=" + this.isPrivate + "&isadult=" + this.isAdult + "&isexternal=" + this.isExternal + "&records=" + this.Records + "&searchtype=" + SearchType + "&pagenumber=1&totalpages=1&sallurl=" + this.See_All_Url + "&sallt=" + this.See_All_Text + "&salltool=" + this.See_All_Url_Tooltip + "&tcolumns=" + this.TotalColumns + "&emode=" + this.EditMode + "&width=" + this.Width + "&height=" + this.Height + "&cnt=" + lst.ClientID + "&sdate=" + this.ShowDate + "&sviews=" + this.ShowViews + "&stitle=" + this.ShowTitle + "&suser=" + this.ShowUser + "&enablenav=" + this.EnableNavigation + "&navcss=" + this.NavigationCssClass + "&navactivecss=" + this.NavigationActiveLinkCssClass + "&enableanim=" + this.EnableAnimation + "&navlinkcss=" + this.NavigationLinkCssClass + "&iscache=" + this.isCache + "&edfnav=" + this.EnableDateFilterNavigation + "&dnavcss=" + DateFilterNavigationCssClass + "&dlinkcss=" + DateFilterLinkCssClass + "&dactivecss=" + DateFilterActiveLinkCssClass + "&aid=" + this.AlbumId;
        nav_param = nav_param + "" + Generate_Nav_Query();
        string ajax_function_name = "Process_Req_Animate";
        if (!this.EnableAnimation)
            ajax_function_name = "Process_Req";

        // current order sequence
        string _order = "v.date_added desc";
        string _tabs = "0";
        if (this.NavigationLinks.Length > 0 && this.NavigationLinkOrderFields.Length > 0)
        {
            int i = 0;
            for (i = 0; i <= this.NavigationLinks.Length - 1; i++)
            {
                if (this.NavigationActiveTab == i)
                {
                    _order = this.NavigationLinkOrderFields[i].ToString();
                    _tabs = i.ToString();
                }

            }
        }
        string today_ajax_event = ajax_function_name + "('" + handler_path + "','" + nav_param + "&order=" + _order + "&tab=" + _tabs + "&afilter=1','#" + lst.ClientID + "','POST',''); return false;";
        string thisweek_ajax_event = ajax_function_name + "('" + handler_path + "','" + nav_param + "&order=" + _order + "&tab=" + _tabs + "&afilter=2','#" + lst.ClientID + "','POST',''); return false;";
        string thismonth_ajax_event = ajax_function_name + "('" + handler_path + "','" + nav_param + "&order=" + _order + "&tab=" + _tabs + "&afilter=3','#" + lst.ClientID + "','POST',''); return false;";
        string alltime_ajax_event = ajax_function_name + "('" + handler_path + "','" + nav_param + "&order=" + _order + "&tab=" + _tabs + "&afilter=0','#" + lst.ClientID + "','POST',''); return false;";

        string today_active_css = "";
        string thisweek_active_css = "";
        string thismonth_active_css = "";
        string all_active_css = "";
        if (DateFilterLinkCssClass != "")
        {
            today_active_css = " class=\"" + this.DateFilterLinkCssClass + "\"";
            thisweek_active_css = " class=\"" + this.DateFilterLinkCssClass + "\"";
            thismonth_active_css = " class=\"" + this.DateFilterLinkCssClass + "\"";
            all_active_css = " class=\"" + this.DateFilterLinkCssClass + "\"";
        }
        switch (this.AddedFilter)
        {
            case 1:
                // today active
                today_active_css = " class=\"" + this.DateFilterActiveLinkCssClass + "\"";
                break;
            case 2:
                // this week active
                thisweek_active_css = " class=\"" + this.DateFilterActiveLinkCssClass + "\"";
                break;
            case 3:
                // this month active
                thismonth_active_css = " class=\"" + this.DateFilterActiveLinkCssClass + "\"";
                break;
            case 0:
                // all time active
                all_active_css = " class=\"" + this.DateFilterActiveLinkCssClass + "\"";
                break;
        }

        //str.Append("<div class=\"" + DateFilterNavigationCssClass + "\">\n");
        //str.Append("<ul>");
        str.Append("<li" + today_active_css + "><a href=\"#\" onclick=\"" + today_ajax_event + "\">" + Resources.vsk.today + "</a></li>\n");
        //str.Append("<li class=\"separator\">|</li>");
        str.Append("<li" + thisweek_active_css + "><a href=\"#\" onclick=\"" + thisweek_ajax_event + "\">" + Resources.vsk.thisweek + "</a></li>\n");
        //str.Append("<li class=\"separator\">|</li>");
        str.Append("<li" + thismonth_active_css + "><a href=\"#\" onclick=\"" + thismonth_ajax_event + "\">" + Resources.vsk.thismonth + "</a></li>\n");
        //str.Append("<li class=\"separator\">|</li>");
        str.Append("<li" + all_active_css + "><a href=\"#\" onclick=\"" + alltime_ajax_event + "\">" + Resources.vsk.alltime + "</a></li>\n");
        //str.Append("</ul>");
        //str.Append("<div class=\"clear\"></div>\n");
        //str.Append("</div>\n");

        return str.ToString();
    }
    private void PrepareBoxTemplates()
    {
        this.BoxCssClass = UGeneral.Return_Box_Css(this.BoxTemplate);
        this.HeadingCssClass = UGeneral.Return_Heading_Css(this.BoxTemplate);
    }

    // Generate query string for nav linkgs and nav order links array list
    private string Generate_Nav_Query()
    {
        return "&navarr=" + string.Join(",", this.NavigationLinks) + "&navarrorder=" + string.Join(",", this.NavigationLinkOrderFields);
    }
}